#!/system/bin/sh

PATH=$PATH:/data/local
export PATH
BB="/data/local/busybox"
FI="/data/local/flash_image"
INSTREC="/system/etc/install-recovery.sh"
MOUNT="$BB mount"
RM="$BB rm"
RECFDR="/sdcard/recoveryflash"
DI="/data/local/dump_image"
RI="/sdcard/recoveryflash/recovery.img"
SLEEP="$BB sleep"
MV="$BB mv"
CP="$BB cp"
RB="/data/local/reboot"

	echo "This must be run from root # shell"
	echo ""

do_prep()
{
	cat $RECFDR/busybox > /data/local/busybox
	cat $RECFDR/flash_image > /data/local/flash_image
	cat $RECFDR/dump_image > /data/local/dump_image
	cat $RECFDR/reboot > /data/local/reboot
	chmod 0755 $BB
	chmod 0755 $FI
	chmod 0755 $DI
	chmod 0755 $RB
	$CP $RECFDR/recovery*.img $RECFDR/recovery.img
	sync
}


get_info()
{
	echo "Device is :" 
	getprop ro.product.board 
	echo ""

	echo "MD5 is :"
	$BB md5sum $RI
	echo ""
}

remove_install_recoverysh()
{
	echo "Removing install-recovery.sh if exists ..."

	$MOUNT -o remount,rw /system
	echo "System remounted as rw"
	echo ""
	echo "Ignore an error stating: '/system/etc/install-recovery.sh': No such file or directory"
	
	$RM $INSTREC
	sync
	echo ""
	$MOUNT -o remount,ro /system
	echo "System remounted ro"
	echo ""
}

dump_current()
{
	echo "Dumping current recovery.img to /sdcard/dump-recovery.img"
	$DI recovery /sdcard/dump-recovery.img
	echo ""
}

flash_recovery()
{
	echo "Flashing new recovery ..."
	$FI recovery $RI
	sync
	echo "Done"
	echo ""
}

reboot_recovery()
{
	echo "Rebooting into recovery in 5 seconds ..."
	$SLEEP 5
	cleanup
	sync
	$RB recovery
	rm $RB
}

cleanup()
{
	$RM $FI
	$RM $DI
	$RM $RI
	rm $BB
	
}

do_main()
{
	do_prep
	get_info
	dump_current
	remove_install_recoverysh
	flash_recovery
	reboot_recovery
}	

do_main


exit 0



